<script setup lang="ts">
import type { Fabrique, Region } from '@/entities';
import { useFabriqueStore } from '@/stores/fabrique';
import { Plus } from '@element-plus/icons-vue';
import type { FormInstance } from 'element-plus';
import { storeToRefs } from 'pinia';
import { ref } from 'vue';

const store = useFabriqueStore();
const { regions } = storeToRefs(store);
const newFabrique = ref<Fabrique>({
        id: 0,
        name: '',
        region: {
            id: 0,
            name: ''
        }
    });
const newRegion = ref<Region>({
    id: 0,
    name: '',
});

console.log(regions)
const status = ref('');
const ruleFormRef = ref<FormInstance>()
const { persistFabrique } = useFabriqueStore();
const { persistRegion } = useFabriqueStore();

const isRegionInputDisplayed = ref<boolean>(false);

async function handleForm() {
    console.log(newFabrique);
    try {
        await persistFabrique(newFabrique.value);
        status.value = 'success';
    } catch (e) {
        console.error(e);
        status.value = 'error';
    }
}

async function createRegion() {
    try {
        newFabrique.value.region = await persistRegion(newRegion.value);
        isRegionInputDisplayed.value = false;
    } catch (e) {
        console.error(e);
        
    }
}

</script>
    
    
<template>
    <el-form ref="ruleFormRef" :model="newFabrique" status-icon>
        <el-form-item label="Nom" prop="name">
            <el-input v-model="newFabrique.name" />
        </el-form-item>
        <div class="region">
            <el-form-item v-if="regions.length > 0" label="Région" prop="region">
                <el-select clearable filterable v-model="newFabrique.region" class="m-2"
                    placeholder="Sélectionner la région" size="large" value-key="id">
                    <el-option v-for="region in regions" :key="region.id" :label="region.name" :value="region" />
                </el-select>
            </el-form-item>

            <el-button class="region-show-input-button" :icon="Plus" type="primary" circle
                @click="isRegionInputDisplayed = !isRegionInputDisplayed" />
            Ajouter une région
        </div>
        <div class="region-input" v-if="isRegionInputDisplayed">
            <el-form-item label="Région" prop="region">
                <el-input v-model="newRegion.name" />
            </el-form-item>
            <el-button type="primary" @click="createRegion()">
                Ajouter la région
            </el-button>
        </div>

        <el-form-item>
            <el-button type="primary" @click="handleForm()">
                Ajouter la fabrique
            </el-button>

        </el-form-item>
    </el-form>

    <el-alert :title="newFabrique.name + ' a bien été ajoutée'" type="success" v-if="status == 'success'" />
    <el-alert :title="'Erreur dans l\'ajout de '+newFabrique.name" type="error" v-if="status == 'error'" />
</template>

<style>
.el-form-item {
    margin: 0;
}

.region {
    margin: 20px 0;
    display: flex;
    align-items: center;

}

.region-show-input-button {
    margin-left: 20px;
    margin-right: 5px;
}

.region-input {
    display: flex;
}
</style>